﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;
using System.Windows;
using System.Windows.Controls;
using System.Windows.Data;
using System.Windows.Documents;
using System.Windows.Input;
using System.Windows.Media;
using System.Windows.Media.Imaging;
using System.Windows.Navigation;
using System.Windows.Shapes;

namespace DataGrid
{
    /// <summary>
    /// Interaction logic for Window1.xaml
    /// </summary>
    public partial class Window1 : Window
    {
        IList<string> orders = new List<string>();
        IList<CustomerOrder> list = new List<CustomerOrder>();

        public Window1()
        {
            InitializeComponent();

            InitializeData(list);
            BuildOrderData(orders);
            Grid.DataSource = list;
        }

        private void InitializeData(IList<CustomerOrder> list)
        {
            list.Add(new CustomerOrder { Customer = "CustomerA", Order = "CustomerA_Order1" });
            list.Add(new CustomerOrder { Customer = "CustomerB", Order = "CustomerB_Order1" });
            list.Add(new CustomerOrder { Customer = "CustomerC", Order = "CustomerC_Order1" });
            list.Add(new CustomerOrder { Customer = "CustomerD", Order = "CustomerD_Order1" });
            list.Add(new CustomerOrder { Customer = "CustomerE", Order = "CustomerE_Order1" });
            list.Add(new CustomerOrder { Customer = "CustomerF", Order = "CustomerF_Order1" });
            list.Add(new CustomerOrder { Customer = "CustomerG", Order = "CustomerG_Order1" });
            list.Add(new CustomerOrder { Customer = "CustomerH", Order = "CustomerH_Order1" });
            list.Add(new CustomerOrder { Customer = "CustomerI", Order = "CustomerI_Order1" });
            list.Add(new CustomerOrder { Customer = "CustomerJ", Order = "CustomerJ_Order1" });
            list.Add(new CustomerOrder { Customer = "CustomerK", Order = "CustomerK_Order1" });
            list.Add(new CustomerOrder { Customer = "CustomerL", Order = "CustomerL_Order1" });
            list.Add(new CustomerOrder { Customer = "CustomerM", Order = "CustomerM_Order1" });
            list.Add(new CustomerOrder { Customer = "CustomerN", Order = "CustomerN_Order1" });
            list.Add(new CustomerOrder { Customer = "CustomerO", Order = "CustomerO_Order1" });
            list.Add(new CustomerOrder { Customer = "CustomerP", Order = "CustomerP_Order1" });
            list.Add(new CustomerOrder { Customer = "CustomerQ", Order = "CustomerQ_Order1" });
            list.Add(new CustomerOrder { Customer = "CustomerR", Order = "CustomerR_Order1" });
            list.Add(new CustomerOrder { Customer = "CustomerS", Order = "CustomerS_Order1" });
            list.Add(new CustomerOrder { Customer = "CustomerT", Order = "CustomerT_Order1" });
            list.Add(new CustomerOrder { Customer = "CustomerU", Order = "CustomerU_Order1" });
            list.Add(new CustomerOrder { Customer = "CustomerV", Order = "CustomerV_Order1" });
            list.Add(new CustomerOrder { Customer = "CustomerW", Order = "CustomerW_Order1" });
            list.Add(new CustomerOrder { Customer = "CustomerX", Order = "CustomerX_Order1" });
            list.Add(new CustomerOrder { Customer = "CustomerY", Order = "CustomerY_Order1" });
            list.Add(new CustomerOrder { Customer = "CustomerZ", Order = "CustomerZ_Order1" });
        }

        private void BuildOrderData(IList<string> list)
        {
            list.Add("CustomerA_Order1");
            list.Add("CustomerA_Order2");
            list.Add("CustomerA_Order3");
            list.Add("CustomerA_Order4");
            list.Add("CustomerA_Order5");
            list.Add("CustomerA_Order6");
            list.Add("CustomerA_Order7");
            list.Add("CustomerA_Order8");
            list.Add("CustomerA_Order9");
            list.Add("CustomerA_Order10");
            list.Add("CustomerB_Order1");
            list.Add("CustomerB_Order2");
            list.Add("CustomerB_Order3");
            list.Add("CustomerB_Order4");
            list.Add("CustomerB_Order5");
            list.Add("CustomerB_Order6");
            list.Add("CustomerB_Order7");
            list.Add("CustomerB_Order8");
            list.Add("CustomerC_Order1");
            list.Add("CustomerC_Order2");
            list.Add("CustomerC_Order3");
            list.Add("CustomerC_Order4");
            list.Add("CustomerC_Order5");
            list.Add("CustomerC_Order6");
            list.Add("CustomerC_Order7");
            list.Add("CustomerC_Order8");
            list.Add("CustomerC_Order9");
            list.Add("CustomerC_Order10");
            list.Add("CustomerD_Order1");
            list.Add("CustomerE_Order1");
            list.Add("CustomerF_Order1");
            list.Add("CustomerG_Order1");
            list.Add("CustomerH_Order1");
            list.Add("CustomerI_Order1");
            list.Add("CustomerJ_Order1");
            list.Add("CustomerK_Order1");
            list.Add("CustomerL_Order1");
            list.Add("CustomerM_Order1");
            list.Add("CustomerN_Order1");
            list.Add("CustomerO_Order1");
            list.Add("CustomerP_Order1");
            list.Add("CustomerQ_Order1");
            list.Add("CustomerR_Order1");
            list.Add("CustomerS_Order1");
            list.Add("CustomerT_Order1");
            list.Add("CustomerU_Order1");
            list.Add("CustomerV_Order1");
            list.Add("CustomerX_Order1");
            list.Add("CustomerY_Order1");
            list.Add("CustomerZ_Order1");
        }

        private void ComboBox_Loaded(object sender, RoutedEventArgs e)
        {
            var comboBox = sender as ComboBox;
            var cvp = comboBox.TemplatedParent as Infragistics.Windows.DataPresenter.CellValuePresenter;
            var co = cvp.Record.DataItem as CustomerOrder;

            if (null != comboBox && null != co)
            {
                comboBox.ItemsSource = (from s in orders
                                        where s.StartsWith(co.Customer)
                                        select s).ToList();
                comboBox.SelectedValue = co.Order;
            }
        }
    }


    public class CustomerOrder
    {
        public string Customer { get; set; }
        public string Order { get; set; }
    }
}
